<template>
<a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
        <a-form-model ref="form" :model="model" :rules="validatorRules" slot="detail">
            <a-row>
                <a-col :span="24">
                    <a-form-model-item label="商品名称" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="goodName">
                        <a-input v-model="model.goodName" placeholder="请输入商品名称"></a-input>
                    </a-form-model-item>
                </a-col>
                <a-col :span="24">
                    <a-form-model-item label="商品规格" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="goodSpe">
                        <a-input v-model="model.goodSpe" placeholder="请输入商品规格"></a-input>
                    </a-form-model-item>
                </a-col>
                <a-col :span="24">
                    <a-form-model-item label="类型" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="type">
                        <a-select v-model="model.type" placeholder="请选择">
                            <a-select-option :value="1">
                                客房易耗品
                            </a-select-option>
                            <a-select-option :value="2">
                                布草
                            </a-select-option>
                        </a-select>
                    </a-form-model-item>
                </a-col>
                <a-col :span="24">
                    <a-form-model-item label="单位" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="">
                        <a-input v-model="model.unit" placeholder="请输入单位"></a-input>
                    </a-form-model-item>
                </a-col>
            </a-row>
        </a-form-model>
    </j-form-container>
</a-spin>
</template>

<script>
import {
    httpAction,
    getAction
} from "@/api/manage";
import {
    validateDuplicateValue
} from "@/utils/util";

export default {
    name: "PosTypeForm",
    components: {},
    props: {
        //表单禁用
        disabled: {
            type: Boolean,
            default: false,
            required: false,
        },
    },
    data() {
        return {
            model: {
                
            },
            labelCol: {
                xs: {
                    span: 24
                },
                sm: {
                    span: 5
                },
            },
            wrapperCol: {
                xs: {
                    span: 24
                },
                sm: {
                    span: 16
                },
            },
            confirmLoading: false,
            validatorRules: {
                goodName: [{
                    required: true,
                    message: "请输入名称!"
                }],
                goodSpe: [{
                    required: true,
                    message: "请输入规格!"
                }],
                type: [{
                    required: true,
                    message: "请选择规格!"
                }],
                unit: [{
                    required: true,
                    message: "请输入单位!"
                }],
                address: [{
                    required: true,
                    message: "请输入地址!"
                }],
            },
            url: {
                add: "/fw/fwRoomConsumable/add",
                edit: "/fw/fwRoomConsumable/edit",
                queryById: "/kc/kcSupplier/queryById",
            },
        };
    },
    computed: {
        formDisabled() {
            return this.disabled;
        },
    },
    created() {
        var _info = JSON.parse(localStorage.getItem("storeInfo"));
        if (_info) {
            this.model.hotelId = _info.id;
        }
        //备份model原始值
        this.modelDefault = JSON.parse(JSON.stringify(this.model));
    },
    methods: {
        add() {
            this.edit(this.modelDefault);
        },
        edit(record) {
            this.model = Object.assign({}, record);
            this.visible = true;
        },
        submitForm() {
            const that = this;
            // 触发表单验证
            this.$refs.form.validate((valid) => {
                if (valid) {
                    that.confirmLoading = true;
                    let httpurl = "";
                    let method = "";
                    if (!this.model.id) {
                        httpurl += this.url.add;
                        method = "post";
                    } else {
                        httpurl += this.url.edit;
                        method = "put";
                    }
                    httpAction(httpurl, this.model, method)
                        .then((res) => {
                            if (res.success) {
                                that.$message.success(res.message);
                                that.$emit("ok");
                            } else {
                                that.$message.warning(res.message);
                            }
                        })
                        .finally(() => {
                            that.confirmLoading = false;
                        });
                }
            });
        },
    },
};
</script>
